<template>
	<div class="bg-white px-3 py-3">
		<el-button type="success" class="float-right" @click="postForm">
			Add New Post <i class="el-icon-circle-plus"></i>
		</el-button>
		<el-dialog title="New Post" :visible.sync="postDialogFormVisible">
		 	<el-form :model="form" ref="form" :rules="rules"  enctype="multipart/form-data">
			    <el-form-item label="Post Title" prop="title" :label-width="formLabelWidth">
			      	<el-input v-model="form.title" autocomplete="off"></el-input>
			    </el-form-item>
			    <el-form-item label="Content" prop="content" :label-width="formLabelWidth">
			      	<el-input 
			      	type="textarea"
  					:autosize="{ minRows: 2, maxRows: 4}"
			      	v-model="form.content" 
			      	autocomplete="off"></el-input>
			    </el-form-item>
		    	<el-form-item label="Category" prop="category_id" :label-width="formLabelWidth">
		      		<el-select v-model="form.category_id" placeholder="Please select a category">
		        		<el-option
		        			v-for="category in categories"
					      	:key="category.id"
					      	:label="category.name"
					      	:value="category.id"></el-option>
		      		</el-select>
		    	</el-form-item>
		    	<el-form-item label="Upload a Photo" prop="image" :label-width="formLabelWidth">
		    		<input class="btn btn-primary ml-0" type="file" v-on:change="onImageChange">
		    	</el-form-item>
		  	</el-form>
		  	<span slot="footer" class="dialog-footer">
		    	<el-button @click="postDialogFormVisible = false">Cancel</el-button>
		    	<el-button type="success" @click="savePostForm('form')">Save</el-button>
		  	</span>
		</el-dialog>
		<el-dialog title="Edit Post" :visible.sync="postEditFormVisible">
		 	<el-form :model="form" ref="form" :rules="rules"  enctype="multipart/form-data">
			    <el-form-item label="Post Title" prop="title" :label-width="formLabelWidth">
			      	<el-input v-model="form.title" autocomplete="off">{{ form.title }}</el-input>
			    </el-form-item>
			    <el-form-item label="Content"  prop="content" :label-width="formLabelWidth">
			      	<el-input 
			      	type="textarea"
  					:autosize="{ minRows: 2, maxRows: 4}"
			      	v-model="form.content" 
			      	autocomplete="off">
			      		{{ form.content }}
			      	</el-input>
			    </el-form-item>
		    	<el-form-item label="Category"  prop="category_id" :label-width="formLabelWidth">
		      		<el-select v-model="form.category_id" placeholder="Please select a category">
		        		<el-option
		        			v-for="category in categories"
					      	:key="category.name"
					      	:label="category.name"
					      	:value="category.id"></el-option>
		      		</el-select>
		    	</el-form-item>
		    	<el-form-item label="Upload a Photo" prop="image" :label-width="formLabelWidth">
		    		<input class="btn btn-primary ml-0" type="file" v-on:change="onImageChange">
		    	</el-form-item>
		  	</el-form>
		  	<span slot="footer" class="dialog-footer">
		    	<el-button @click="postEditFormVisible = false">Cancel</el-button>
		    	<el-button type="success" @click="updatePostForm('form', form.id)">Update</el-button>
		  	</span>
		</el-dialog>
		<el-table
			:data="posts.data"
			style="width: 100%"
			:row-class-name="tableRowClassName"
			v-loading="loading"
			:fit="true">
			<el-table-column
		      type="index"
		      width="50">
		    </el-table-column>
		    <el-table-column
		      label="Title"
		      prop="title"
		      width="200">
		    </el-table-column>
		    <el-table-column
		      label="Content"
		      prop="content"
		      width="300">
		    </el-table-column>
		    <el-table-column
		      label="Published at"
		      prop="updated_at"
		      width="230">
		    </el-table-column>
		    <el-table-column
		      	align="left"
		      	width="270">
		      	<template slot-scope="scope">
		        	<el-button
		          		size="mini"
		          		type="info"
		          		@click="getPost(scope.row.id)">Edit</el-button>
		        	<el-button
		          		size="mini"
		          		type="danger"
		          		@click="deletePostModal(scope.row.id)">Delete</el-button>
		      	</template>
		    </el-table-column>
		</el-table>
		<pagination :data="posts" @pagination-change-page="getPosts"></pagination>
	</div>
</template>

<style>
  	.el-table .warning-row {
    	background: oldlace;
  	}
  	.el-table .success-row {
    	background: #f0f9eb;
  	}
</style>

<script>
	export default {
		data() {
			return {
	      		loading: false,
	      		posts: {},
	      		categories: [],
       			formLabelWidth: '130px',
				labelPosition: 'top',
	      		isCollapse: false,
		        search: '',
				postDialogFormVisible: false,
				postEditFormVisible: false,
				form: {
					id: '',
	          		title: '',
		          	content: '',
        			image: '',
        			category_id: '',
        		},
        		rules: {
		        	title: [
		            	{ required: true, message: 'Please input Job title', trigger: 'blur' }
		          	],
		          	content: [
		            	{ required: true, message: 'Please select Content', trigger: 'blur' }
		          	],
		          	category_id: [
		            	{ required: true, message: 'Please select one Category', trigger: 'blur' }
		          	],
		          	image: [
		            	{ required: true, message: 'Please choose a image', trigger: 'blur' },
		          	],
		        }
			}
		},
		methods: {
			postForm () {
				this.postDialogFormVisible = true;
				this.form.id = '';
				this.form.title = '';
				this.form.content = '';
				this.form.category_id = '';
			},
  			onImageChange(e){
                this.form.image = e.target.files[0];
            },
            savePostForm(formName) {
				this.$refs[formName].validate((valid) => {
            	    if (valid) {
	    	            const config = {
	    	                headers: { 'content-type': 'multipart/form-data' }
	    	            }

	    	            let formData = new FormData();
	    	            formData.append('user_id', this.$auth.user().id);
	    	            formData.append('title', this.form.title);
	    	            formData.append('content', this.form.content);
	    	            formData.append('category_id', this.form.category_id);
	    	            formData.append('image', this.form.image);

	    	            axios.post('/posts', formData, config)
	    	            .then(response => {
	    	            	this.posts = {};
                			this.getPosts();
	    	                this.$message({
			                	type: 'success',
			                	message: 'Successfully created',
	    	                });
	    	                this.form.image = '';
	    	                this.$refs[formName].resetFields();
	    	                this.postDialogFormVisible = false;
	    	            })
	    	            .catch(error => {
				          	this.$message({
			                	type: 'warning',
			                	message: error.response.data.errors.image[0],
	    	                });
				      	})
	    	        } else {
	    	            this.$message({
		                	type: 'warning',
		                	message: 'Please check and input correct fields!',
    	                });
	    	            return false;
	    	        }
            	})
			},
			updatePostForm(formName, id) {
				this.$refs[formName].validate((valid) => {
            	    if (valid) {
	    	            const config = {
		                    headers: { 'content-type': 'multipart/form-data' }
		                };

		                let formData = new FormData();
		                formData.append('_method', 'PATCH');
		                formData.append('title', this.form.title);
		                formData.append('content', this.form.content);
		                formData.append('category_id', this.form.category_id);
		                formData.append('image', this.form.image);
		                
						axios.post('/posts/' + id, formData)
						.then(() => {
				           	this.$message({
				             	type: 'success',
				             	message: 'Changes saved.',
				           	});
				           	this.getPosts();
				           	this.postEditFormVisible = false;
			         	})
	    	        } else {
	    	            this.$message({
		                	type: 'warning',
		                	message: 'Please check and input correct fields!',
    	                });
	    	            return false;
	    	        }
            	})
			},
            getPosts(page) {
            	this.loading = true;

            	if (typeof page === 'undefined') {
					page = 1;
				}
				axios.get('/posts?page=' + page)
				.then(response => {
					this.posts = [];
					this.posts = response.data;
				})
				.catch(function (error) {
                    console.log(error);
                });
                this.loading = false;
                this.getCategories();
			},
			getCategories() {
            	this.loading = true;
				axios.get('/categories/allCategories')
				.then(response => {
					this.categories = response.data;
				})
				.catch(function (error) {
                    console.log(error);
                });
                this.loading = false;
			},
			editImageChange(e){
                console.log(this.editForm.image);
                this.editForm.image = e.target.files[0];
            },
	    	tableRowClassName({row, rowIndex}) {
		        if (rowIndex === 1) {
		          return 'warning-row';
		        } else if (rowIndex === 3) {
		          return 'success-row';
		        }
		        return '';
		    },
			getPost(id) {
				this.postEditFormVisible = true;
                
				axios.get('/posts/' + id +'/edit')
				.then(response => {
					this.form.id = response.data.id;
					this.form.title = response.data.title;
					this.form.content = response.data.content;
					this.form.image = response.data.image;
					this.form.category_id = response.data.category_id;
				});
			},
			updatePost(id) {
                const config = {
                    headers: { 'content-type': 'multipart/form-data' }
                };

                let formData = new FormData();
                formData.append('_method', 'PATCH');
                formData.append('title', this.form.title);
                formData.append('content', this.form.content);
                formData.append('category_id', this.form.category_id);
                formData.append('image', this.form.image);
                
				axios.post('/posts/' + id, formData)
				.then(() => {
		           	this.$message({
		             	type: 'success',
		             	message: 'Changes saved.',
		           	});
		           	this.getPosts();
		           	this.postEditFormVisible = false;
	         	})
			},
			deletePost(id) {
				axios.delete('/posts/' +id)
				.then(response => {
					this.getPosts();
				})
				.catch (function(error){
					console.log(error);
				})
			},
			deletePostModal(id) {
	            this.$confirm('This will permanently delete the data. Continue?', 'Warning', {
	              	confirmButtonText: 'OK',
	              	cancelButtonText: 'Cancel',
	              	type: 'warning'
	            })
	            .then(() => {
	              	this.$message({
	                	type: 'success',
	                	message: 'Delete completed',
	                	option: this.deletePost(id)
	              	});
	            })
	            .catch(() => {
	              	this.$message({
	                	type: 'info',
	                	message: 'Delete canceled'
	            	});          
            	})
            },
		},
		mounted() {
			this.getCategories();
			this.getPosts();
		}
	}
</script>